Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Context_State/src/Context_State_transition.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Context_State/src/Context_State_transition.cpp	(revision 97)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Context_State/src/Context_State_transition.cpp	(revision 98)
@@ -40,10 +40,11 @@
           if (PORT_READ(in_BRANCH_EVENT_VAL [i]) and internal_BRANCH_EVENT_ACK [i])
             {
+              log_printf(TRACE,Context_State,FUNCTION,"  * BRANCH_EVENT [%d]",i);
+
 //               throw ERRORMORPHEO(FUNCTION,_("Not yet implemented (Comming Soon).\n"));
 
               context_state_t state = reg_STATE [i];
 
-              Tdepth_t   depth      = // (_param->_have_port_depth)?PORT_READ(in_BRANCH_EVENT_DEPTH [i]):
-                0;
+              Tdepth_t   depth      = (_param->_have_port_depth)?PORT_READ(in_BRANCH_EVENT_DEPTH [i]):0;
               Tdepth_t   depth_cur  = reg_EVENT_DEPTH [i];
               Tdepth_t   depth_min  = (_param->_have_port_depth)?PORT_READ(in_DEPTH_MIN [i]):0;
@@ -61,9 +62,9 @@
               // is_valid = can modify local information
               //   if context_state_ok : yes
-              //   if context_state_ko : test the depth, and the priority of envent
+              //   if context_state_ko : test the depth, and the priority of event
 
               bool       is_valid   = ((state == CONTEXT_STATE_OK) or
                                        (depth1< depth0) or
-                                       ((depth1==depth0) and (priority1>priority0)));
+                                       ((depth1==depth0) and (priority1>=priority0))); // >= because another branch can be a miss prediction with same depth
 
               if (is_valid)
@@ -76,5 +77,5 @@
                 //reg_EVENT_ADDRESS_EEAR     [i] =  0; 
                   reg_EVENT_ADDRESS_EEAR_VAL [i] =  0;
-                  reg_EVENT_IS_DELAY_SLOT    [i] =  dest_val;
+                  reg_EVENT_IS_DELAY_SLOT    [i] =  1;
                   reg_EVENT_IS_DS_TAKE       [i] =  dest_val;
                   reg_EVENT_DEPTH            [i] =  depth;
@@ -89,4 +90,6 @@
           if (PORT_READ(in_DECOD_EVENT_VAL [i]) and internal_DECOD_EVENT_ACK [i])
             {
+              log_printf(TRACE,Context_State,FUNCTION,"  * DECOD_EVENT [%d]",i);
+
               Tcontext_t context    = (_param->_have_port_context_id )?PORT_READ(in_DECOD_EVENT_CONTEXT_ID [i]):0;
               Tdepth_t   depth      = (_param->_have_port_depth      )?PORT_READ(in_DECOD_EVENT_DEPTH      [i]):0;
@@ -190,4 +193,6 @@
         if (PORT_READ(in_COMMIT_EVENT_VAL ) and internal_COMMIT_EVENT_ACK )
           {
+            log_printf(TRACE,Context_State,FUNCTION,"  * COMMIT_EVENT");
+
             Tcontext_t context    = (_param->_have_port_context_id)?PORT_READ(in_COMMIT_EVENT_CONTEXT_ID ):0;
             Tdepth_t   depth      = (_param->_have_port_depth     )?PORT_READ(in_COMMIT_EVENT_DEPTH      ):0;
@@ -252,50 +257,51 @@
         // -------------------------------------------------------------------
 
-        for (uint32_t i=0; i<_param->_nb_inst_branch_complete; i++)
-          if (PORT_READ(in_BRANCH_COMPLETE_VAL [i]) and internal_BRANCH_COMPLETE_ACK [i])
-            {
-              if (PORT_READ(in_BRANCH_COMPLETE_MISS_PREDICTION [i]))
-                {
-                  Tcontext_t context    = (_param->_have_port_context_id)?PORT_READ(in_BRANCH_COMPLETE_CONTEXT_ID [i]):0;
-                  Tdepth_t   depth      = (_param->_have_port_depth     )?PORT_READ(in_BRANCH_COMPLETE_DEPTH      [i]):0;
-                  Tdepth_t   depth_cur  = reg_EVENT_DEPTH [context];
-                  Tdepth_t   depth_min = (_param->_have_port_depth     )?PORT_READ(in_DEPTH_MIN [context]):0;
-                  Tdepth_t   depth_max  = _param->_array_size_depth [context];
+//         for (uint32_t i=0; i<_param->_nb_inst_branch_complete; i++)
+//           if (PORT_READ(in_BRANCH_COMPLETE_VAL [i]) and internal_BRANCH_COMPLETE_ACK [i])
+//             {
+//               log_printf(TRACE,Context_State,FUNCTION,"  * BRANCH_COMPLETE [%d]",i);
+//               if (PORT_READ(in_BRANCH_COMPLETE_MISS_PREDICTION [i]))
+//                 {
+//                   Tcontext_t context    = (_param->_have_port_context_id)?PORT_READ(in_BRANCH_COMPLETE_CONTEXT_ID [i]):0;
+//                   Tdepth_t   depth      = (_param->_have_port_depth     )?PORT_READ(in_BRANCH_COMPLETE_DEPTH      [i]):0;
+//                   Tdepth_t   depth_cur  = reg_EVENT_DEPTH [context];
+//                   Tdepth_t   depth_min = (_param->_have_port_depth     )?PORT_READ(in_DEPTH_MIN [context]):0;
+//                   Tdepth_t   depth_max  = _param->_array_size_depth [context];
                   
-//                   Tdepth_t   depth0     = (depth_cur>=depth_min)?(depth_cur-depth_min):((depth_cur+depth_max-depth_min));
-//                   Tdepth_t   depth1     = (depth    >=depth_min)?(depth    -depth_min):((depth    +depth_max-depth_min));
-                  Tdepth_t   depth0     = (depth_cur>=depth_min)?(depth_cur):((depth_cur+depth_max));
-                  Tdepth_t   depth1     = (depth    >=depth_min)?(depth    ):((depth    +depth_max));
+// //                   Tdepth_t   depth0     = (depth_cur>=depth_min)?(depth_cur-depth_min):((depth_cur+depth_max-depth_min));
+// //                   Tdepth_t   depth1     = (depth    >=depth_min)?(depth    -depth_min):((depth    +depth_max-depth_min));
+//                   Tdepth_t   depth0     = (depth_cur>=depth_min)?(depth_cur):((depth_cur+depth_max));
+//                   Tdepth_t   depth1     = (depth    >=depth_min)?(depth    ):((depth    +depth_max));
                   
-                  context_state_t state = reg_STATE [context];
+//                   context_state_t state = reg_STATE [context];
                   
-                  // miss > excep > spr/sync
-                  uint8_t    priority0  = (state == CONTEXT_STATE_KO_MISS)?2:((state == CONTEXT_STATE_KO_EXCEP)?1:0);
-                  uint8_t    priority1  = 2; // miss
+//                   // miss > excep > spr/sync
+//                   uint8_t    priority0  = (state == CONTEXT_STATE_KO_MISS)?2:((state == CONTEXT_STATE_KO_EXCEP)?1:0);
+//                   uint8_t    priority1  = 2; // miss
                   
-                  // is_valid = can modify local information
-                  //  if context_state_ok : yes
-                  //  if context_state_ko : test the depth, and the priority of envent
+//                   // is_valid = can modify local information
+//                   //  if context_state_ok : yes
+//                   //  if context_state_ko : test the depth, and the priority of envent
                   
-                  bool       is_valid   = ((state == CONTEXT_STATE_OK) or
-                                           (depth1< depth0) or
-                                           ((depth1==depth0) and (priority1>priority0)));
+//                   bool       is_valid   = ((state == CONTEXT_STATE_OK) or
+//                                            (depth1< depth0) or
+//                                            ((depth1==depth0) and (priority1>priority0)));
                   
-                  if (is_valid)
-                    {
-                      // commit
-                      Tcontrol_t take = PORT_READ(in_BRANCH_COMPLETE_TAKE [i]);
-                      reg_STATE                  [context] = CONTEXT_STATE_KO_MISS;
-                      reg_EVENT_ADDRESS          [context] = PORT_READ(in_BRANCH_COMPLETE_ADDRESS_SRC  [i])+1; //DELAY_SLOT
-                      reg_EVENT_ADDRESS_EPCR     [context] = PORT_READ(in_BRANCH_COMPLETE_ADDRESS_DEST [i]); 
-                      reg_EVENT_ADDRESS_EPCR_VAL [context] = take; // if not take : in sequence
-                    //reg_EVENT_ADDRESS_EEAR     [context]; 
-                      reg_EVENT_ADDRESS_EEAR_VAL [context] = 0;
-                      reg_EVENT_IS_DELAY_SLOT    [context] = take;
-                      reg_EVENT_IS_DS_TAKE       [context] = take;
-                      reg_EVENT_DEPTH            [context] = depth;
-                    }
-                }
-            }
+//                   if (is_valid)
+//                     {
+//                       // commit
+//                       Tcontrol_t take = PORT_READ(in_BRANCH_COMPLETE_TAKE [i]);
+//                       reg_STATE                  [context] = CONTEXT_STATE_KO_MISS;
+//                       reg_EVENT_ADDRESS          [context] = PORT_READ(in_BRANCH_COMPLETE_ADDRESS_SRC  [i])+1; //DELAY_SLOT
+//                       reg_EVENT_ADDRESS_EPCR     [context] = PORT_READ(in_BRANCH_COMPLETE_ADDRESS_DEST [i]); 
+//                       reg_EVENT_ADDRESS_EPCR_VAL [context] = take; // if not take : in sequence
+//                     //reg_EVENT_ADDRESS_EEAR     [context]; 
+//                       reg_EVENT_ADDRESS_EEAR_VAL [context] = 0;
+//                       reg_EVENT_IS_DELAY_SLOT    [context] = take;
+//                       reg_EVENT_IS_DS_TAKE       [context] = take;
+//                       reg_EVENT_DEPTH            [context] = depth;
+//                     }
+//                 }
+//             }
 
         // -------------------------------------------------------------------
@@ -305,4 +311,5 @@
           if (internal_EVENT_VAL [i] and PORT_READ(in_EVENT_ACK [i]))
             {
+              log_printf(TRACE,Context_State,FUNCTION,"  * EVENT [%d]",i);
               // Write pc
               context_state_t state = reg_STATE [i];
@@ -338,4 +345,6 @@
           if (internal_SPR_EVENT_VAL [i] and PORT_READ(in_SPR_EVENT_ACK [i]))
             {
+              log_printf(TRACE,Context_State,FUNCTION,"  * SPR_EVENT [%d]",i);
+
               // Write spr
 #ifdef DEBUG_TEST
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Context_State/src/Parameters.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Context_State/src/Parameters.cpp	(revision 97)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Context_State/src/Parameters.cpp	(revision 98)
@@ -23,5 +23,5 @@
 			  uint32_t   nb_inst_branch_complete,
 			  uint32_t * size_depth,                
-			  uint32_t   size_address,
+			  uint32_t   size_general_data,
 			  uint32_t * size_nb_inst_decod,           
 			  uint32_t   size_nb_inst_commit,          
@@ -35,5 +35,5 @@
     _nb_inst_branch_complete       = nb_inst_branch_complete      ;
     _array_size_depth              = size_depth                   ;
-//  _size_address                  = size_address                 ;
+//  _size_general_data             = size_general_data            ;
 //  _size_nb_inst_decod            = size_nb_inst_decod           ;
 //  _size_nb_inst_commit           = size_nb_inst_commit          ;
@@ -46,5 +46,6 @@
         _size_context_id               = log2(_nb_context);
         _size_depth                    = log2(max<uint32_t>(size_depth,_nb_context));
-        _size_instruction_address      = size_address;
+        _size_general_data             = size_general_data;
+        _size_instruction_address      = size_general_data-2;
         _size_nb_inst_decod            = max<uint32_t>(size_nb_inst_decod,_nb_decod_unit);
         _size_nb_inst_commit           = size_nb_inst_commit;
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Ifetch_unit/Address_management/src/Address_management_transition.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Ifetch_unit/Address_management/src/Address_management_transition.cpp	(revision 97)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Ifetch_unit/Address_management/src/Address_management_transition.cpp	(revision 98)
@@ -145,8 +145,8 @@
             // Because, is not ds take, can continue in sequence
 
-#ifdef DEBUG_TEST
-            if (PORT_READ(in_EVENT_ADDRESS_NEXT_VAL) and not PORT_READ(in_EVENT_IS_DS_TAKE))
-              throw ERRORMORPHEO(FUNCTION,_("Event : address_next_next_val but next is not a ds take"));
-#endif
+// #ifdef DEBUG_TEST
+//             if (PORT_READ(in_EVENT_ADDRESS_NEXT_VAL) and not PORT_READ(in_EVENT_IS_DS_TAKE))
+//               throw ERRORMORPHEO(FUNCTION,_("Event : address_next_next_val but next is not a ds take"));
+// #endif
 
 #ifdef STATISTICS
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Branch_Target_Buffer/Branch_Target_Buffer_Glue/src/Branch_Target_Buffer_Glue_genMealy_decod.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Branch_Target_Buffer/Branch_Target_Buffer_Glue/src/Branch_Target_Buffer_Glue_genMealy_decod.cpp	(revision 97)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Branch_Target_Buffer/Branch_Target_Buffer_Glue/src/Branch_Target_Buffer_Glue_genMealy_decod.cpp	(revision 98)
@@ -22,24 +22,46 @@
   void Branch_Target_Buffer_Glue::genMealy_decod (void)
   {
-    log_printf(FUNC,Branch_Target_Buffer_Glue,FUNCTION,"Begin");
+    log_begin(Branch_Target_Buffer_Glue,FUNCTION);
+    log_function(Branch_Target_Buffer_Glue,FUNCTION,_name.c_str());
 
     for (uint32_t i=0; i<_param->_nb_inst_decod; i++)
       {
+        log_printf(TRACE,Branch_Target_Buffer_Glue,FUNCTION,"  * DECOD [%d]",i);
 	Tcontrol_t val          = PORT_READ(in_DECOD_VAL          [i]);
 	Tcontrol_t register_ack = PORT_READ(in_DECOD_REGISTER_ACK [i]);
 	Tcontrol_t victim_ack   = (_param->_have_port_victim)?PORT_READ(in_DECOD_VICTIM_ACK [i]):true;
 	
-	PORT_WRITE(out_DECOD_ACK            [i],         register_ack and victim_ack);
-	PORT_WRITE(out_DECOD_REGISTER_VAL   [i], val and                  victim_ack);
+        log_printf(TRACE,Branch_Target_Buffer_Glue,FUNCTION,"    * val          : %d", val         );
+        log_printf(TRACE,Branch_Target_Buffer_Glue,FUNCTION,"    * register_ack : %d", register_ack);
+        log_printf(TRACE,Branch_Target_Buffer_Glue,FUNCTION,"    * victim_ack   : %d", victim_ack  );
 
+	PORT_WRITE(out_DECOD_ACK            [i], (
+//                                                val          and
+                                                  register_ack and 
+                                                  victim_ack
+                                                  ));
+        PORT_WRITE(out_DECOD_REGISTER_VAL   [i], (
+                                                  val          and
+//                                                register_ack and 
+                                                  victim_ack
+                                                  ));
 	if (_param->_have_port_victim)
 	  {
-	PORT_WRITE(out_DECOD_VICTIM_VAL     [i], val and register_ack );
+	PORT_WRITE(out_DECOD_VICTIM_VAL     [i], (
+                                                  val          and
+                                                  register_ack // and 
+//                                                victim_ack
+                                                  ));
 	if (not _param->_is_full_associative)
-	PORT_WRITE(out_DECOD_VICTIM_ADDRESS [i], (PORT_READ(in_DECOD_ADDRESS_SRC [i]) >> _param->_shift_bank)&_param->_mask_bank);
+          {
+            Tgeneral_data_t address_src = PORT_READ(in_DECOD_ADDRESS_SRC [i]);
+            log_printf(TRACE,Branch_Target_Buffer_Glue,FUNCTION,"    * address_src  : %.8x", address_src);
+            
+            PORT_WRITE(out_DECOD_VICTIM_ADDRESS [i], (address_src >> _param->_shift_bank)&_param->_mask_bank);
+          }
 	  }
       }
 
-    log_printf(FUNC,Branch_Target_Buffer_Glue,FUNCTION,"End");
+    log_end(Branch_Target_Buffer_Glue,FUNCTION);
   };
 
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Branch_Target_Buffer/Branch_Target_Buffer_Glue/src/Branch_Target_Buffer_Glue_genMealy_predict.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Branch_Target_Buffer/Branch_Target_Buffer_Glue/src/Branch_Target_Buffer_Glue_genMealy_predict.cpp	(revision 97)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Branch_Target_Buffer/Branch_Target_Buffer_Glue/src/Branch_Target_Buffer_Glue_genMealy_predict.cpp	(revision 98)
@@ -22,15 +22,21 @@
   void Branch_Target_Buffer_Glue::genMealy_predict (void)
   {
-    log_printf(FUNC,Branch_Target_Buffer_Glue,FUNCTION,"Begin");
+    log_begin(Branch_Target_Buffer_Glue,FUNCTION);
+    log_function(Branch_Target_Buffer_Glue,FUNCTION,_name.c_str());
 
     for (uint32_t i=0; i<_param->_nb_inst_predict; i++)
       {
-	Tptr_t          index = (_param->_have_port_victim)?PORT_READ(in_PREDICT_SORT_INDEX [i]):0;
-	Tcontrol_t      hit   = PORT_READ(in_PREDICT_REGISTER_HIT         [i][index]);
-	Tgeneral_data_t addr  = PORT_READ(in_PREDICT_REGISTER_ADDRESS_SRC [i][index]);
+        log_printf(TRACE,Branch_Target_Buffer_Glue,FUNCTION,"  * PREDICT [%d]",i);
+	Tptr_t          index       = (_param->_have_port_victim)?PORT_READ(in_PREDICT_SORT_INDEX [i]):0;
+	Tcontrol_t      hit         = PORT_READ(in_PREDICT_REGISTER_HIT         [i][index]);
+	Tgeneral_data_t address_src = PORT_READ(in_PREDICT_REGISTER_ADDRESS_SRC [i][index]);
+
+        log_printf(TRACE,Branch_Target_Buffer_Glue,FUNCTION,"    * index        : %d"  ,index      );
+        log_printf(TRACE,Branch_Target_Buffer_Glue,FUNCTION,"    * hit          : %d"  ,hit        );
+        log_printf(TRACE,Branch_Target_Buffer_Glue,FUNCTION,"    * address_src  : %.8x",address_src);
 
 	// Multiplexor
 	PORT_WRITE(out_PREDICT_HIT          [i],hit);
-	PORT_WRITE(out_PREDICT_ADDRESS_SRC  [i],addr);
+	PORT_WRITE(out_PREDICT_ADDRESS_SRC  [i],address_src);
 	PORT_WRITE(out_PREDICT_ADDRESS_DEST [i],PORT_READ(in_PREDICT_REGISTER_ADDRESS_DEST  [i][index]));
 	PORT_WRITE(out_PREDICT_CONDITION    [i],PORT_READ(in_PREDICT_REGISTER_CONDITION     [i][index]));
@@ -42,19 +48,39 @@
 	Tcontrol_t sort_val     = (_param->_have_port_victim)?PORT_READ(in_PREDICT_SORT_VAL   [i]):true;
 	Tcontrol_t victim_ack   = (_param->_have_port_victim)?PORT_READ(in_PREDICT_VICTIM_ACK [i]):true;
+
+        log_printf(TRACE,Branch_Target_Buffer_Glue,FUNCTION,"    * val          : %d",val         );
+        log_printf(TRACE,Branch_Target_Buffer_Glue,FUNCTION,"    * register_ack : %d",register_ack);
+        log_printf(TRACE,Branch_Target_Buffer_Glue,FUNCTION,"    * sort_val     : %d",sort_val    );
+        log_printf(TRACE,Branch_Target_Buffer_Glue,FUNCTION,"    * victim_ack   : %d",victim_ack  );
 	
-	PORT_WRITE(out_PREDICT_ACK            [i],         register_ack and sort_val and victim_ack);
-	PORT_WRITE(out_PREDICT_REGISTER_VAL   [i], val and                  sort_val and victim_ack);
+	PORT_WRITE(out_PREDICT_ACK            [i], (
+//                                                  val          and 
+                                                    register_ack and
+                                                    sort_val     and
+                                                    victim_ack
+                                                    ));
+	PORT_WRITE(out_PREDICT_REGISTER_VAL   [i], (
+                                                    val          and 
+//                                                  register_ack and
+                                                    sort_val     and
+                                                    victim_ack
+                                                    ));
 
 	if (_param->_have_port_victim)
 	  {
-	PORT_WRITE(out_PREDICT_VICTIM_VAL     [i], val and register_ack and sort_val               );
+	PORT_WRITE(out_PREDICT_VICTIM_VAL     [i], (
+                                                    val          and 
+                                                    register_ack and
+                                                    sort_val     // and
+//                                                  victim_ack
+                                                    ));
 	PORT_WRITE(out_PREDICT_VICTIM_HIT     [i], hit);
 	if (not _param->_is_full_associative)
-	PORT_WRITE(out_PREDICT_VICTIM_ADDRESS [i], (addr >> _param->_shift_bank)&_param->_mask_bank);
+	PORT_WRITE(out_PREDICT_VICTIM_ADDRESS [i], (address_src >> _param->_shift_bank)&_param->_mask_bank);
 	PORT_WRITE(out_PREDICT_VICTIM_INDEX   [i], index);
 	  }
       }
 
-    log_printf(FUNC,Branch_Target_Buffer_Glue,FUNCTION,"End");
+    log_end(Branch_Target_Buffer_Glue,FUNCTION);
   };
 
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Branch_Target_Buffer/Branch_Target_Buffer_Glue/src/Branch_Target_Buffer_Glue_genMealy_update.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Branch_Target_Buffer/Branch_Target_Buffer_Glue/src/Branch_Target_Buffer_Glue_genMealy_update.cpp	(revision 97)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Branch_Target_Buffer/Branch_Target_Buffer_Glue/src/Branch_Target_Buffer_Glue_genMealy_update.cpp	(revision 98)
@@ -22,11 +22,18 @@
   void Branch_Target_Buffer_Glue::genMealy_update (void)
   {
-    log_printf(FUNC,Branch_Target_Buffer_Glue,FUNCTION,"Begin");
+    log_begin(Branch_Target_Buffer_Glue,FUNCTION);
+    log_function(Branch_Target_Buffer_Glue,FUNCTION,_name.c_str());
 
     for (uint32_t i=0; i<_param->_nb_inst_update; i++)
       {
-	Tcontrol_t val          = PORT_READ(in_UPDATE_VAL          [i]);
-	Tcontrol_t register_ack = PORT_READ(in_UPDATE_REGISTER_ACK [i]);
-	Tcontrol_t victim_ack   = (_param->_have_port_victim)?PORT_READ(in_UPDATE_VICTIM_ACK [i]):true;
+        log_printf(TRACE,Branch_Target_Buffer_Glue,FUNCTION,"  * UPDATE [%d]",i);
+
+	Tcontrol_t      val          = PORT_READ(in_UPDATE_VAL          [i]);
+	Tcontrol_t      register_ack = PORT_READ(in_UPDATE_REGISTER_ACK [i]);
+	Tcontrol_t      victim_ack   = (_param->_have_port_victim)?PORT_READ(in_UPDATE_VICTIM_ACK [i]):true;
+
+        log_printf(TRACE,Branch_Target_Buffer_Glue,FUNCTION,"    * val          : %d",val         );
+        log_printf(TRACE,Branch_Target_Buffer_Glue,FUNCTION,"    * register_ack : %d",register_ack);
+        log_printf(TRACE,Branch_Target_Buffer_Glue,FUNCTION,"    * victim_ack   : %d",victim_ack  );
 	
 	PORT_WRITE(out_UPDATE_ACK            [i],         register_ack and victim_ack);
@@ -37,9 +44,14 @@
 	PORT_WRITE(out_UPDATE_VICTIM_VAL     [i], val and register_ack );
 	if (not _param->_is_full_associative)
-	PORT_WRITE(out_UPDATE_VICTIM_ADDRESS [i], (PORT_READ(in_UPDATE_ADDRESS_SRC [i]) >> _param->_shift_bank)&_param->_mask_bank);
+          {
+        Tgeneral_data_t address_src  = PORT_READ(in_UPDATE_ADDRESS_SRC  [i]);
+        log_printf(TRACE,Branch_Target_Buffer_Glue,FUNCTION,"    * address_src  : %.8x",address_src);
+
+	PORT_WRITE(out_UPDATE_VICTIM_ADDRESS [i], (address_src >> _param->_shift_bank)&_param->_mask_bank);
+          }
 	  }
       }
 
-    log_printf(FUNC,Branch_Target_Buffer_Glue,FUNCTION,"End");
+    log_end(Branch_Target_Buffer_Glue,FUNCTION);
   };
 
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Branch_Target_Buffer/Branch_Target_Buffer_Glue/src/Parameters.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Branch_Target_Buffer/Branch_Target_Buffer_Glue/src/Parameters.cpp	(revision 97)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Branch_Target_Buffer/Branch_Target_Buffer_Glue/src/Parameters.cpp	(revision 98)
@@ -48,5 +48,5 @@
 
     _mask_bank              = gen_mask<Tgeneral_data_t> (_size_victim_address);
-    _shift_bank             = log2(max_nb_instruction)+2;
+    _shift_bank             = log2(max_nb_instruction);
 
     test();
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Branch_Target_Buffer/Branch_Target_Buffer_Register/src/Parameters.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Branch_Target_Buffer/Branch_Target_Buffer_Register/src/Parameters.cpp	(revision 97)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Branch_Target_Buffer/Branch_Target_Buffer_Register/src/Parameters.cpp	(revision 98)
@@ -60,5 +60,5 @@
     _mask_offset  = gen_mask<Tgeneral_data_t> (size_offset);
     _mask_bank    = gen_mask<Tgeneral_data_t> (size_bank  );
-    _shift_offset = 2;
+    _shift_offset = 0;
     _shift_bank   = _shift_offset+size_offset;
     _shift_tag    = _shift_bank  +size_bank  ;
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Prediction_unit_Glue/src/Prediction_unit_Glue_allocation.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Prediction_unit_Glue/src/Prediction_unit_Glue_allocation.cpp	(revision 97)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Prediction_unit_Glue/src/Prediction_unit_Glue_allocation.cpp	(revision 98)
@@ -270,12 +270,4 @@
     // ~~~~~[ Register ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~    
 
-#ifndef REGISTER_INIT
-    if (usage_is_set(_usage,USE_SYSTEMC))
-      {
-        reg_PREDICT_PRIORITY = 0;
-        reg_DECOD_PRIORITY   = 0;
-      }
-#endif
-
     // ~~~~~[ Component ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~    
 
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Prediction_unit_Glue/src/Prediction_unit_Glue_genMealy_decod.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Prediction_unit_Glue/src/Prediction_unit_Glue_genMealy_decod.cpp	(revision 97)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Prediction_unit_Glue/src/Prediction_unit_Glue_genMealy_decod.cpp	(revision 98)
@@ -25,4 +25,6 @@
     log_function(Prediction_unit_Glue,FUNCTION,_name.c_str());
 
+    if (PORT_READ(in_NRESET))
+      {
     // Init
     uint32_t   decod_unit = reg_DECOD_PRIORITY;
@@ -262,5 +264,5 @@
 	else
 	  PORT_WRITE(out_DECOD_ACK [i][j], ack[j]);
-
+      }
     log_end(Prediction_unit_Glue,FUNCTION);
   };
